<?php

// GZip output
ob_start("ob_gzhandler");

$config = array();
$MARC_config = array();
$MARCsyn_config = array();
$MARC_searchable = array();
$MARC_editable = array();
$MARC_display_in_list = array();
$MARC_display_extended = array();
$page_config = array();
$site_config = array();

//<-----
//	readConfig:	Reads the config and MARC_config file and parses the values into
//				the $config and $MARC_config hash respectively.
//----->
function read_config ($conf_file = 'config', $MARC_conf_file = 'MARC_config', $MARCsyn_conf_file = 'MARCsyn_config', $page_conf_file = 'page_config', $site_conf_file = 'site_config')
{
        global	$config,
				$MARC_config,
				$MARCsyn_config,
				$page_config,
				$site_config;

        $config = parse_ini_file($conf_file);
		$MARC_config = parse_ini_file($MARC_conf_file);
		$MARCsyn_config = parse_ini_file($MARCsyn_conf_file);
		$page_config = config_to_array($page_conf_file);
		$site_config = parse_ini_file($site_conf_file, TRUE);  //defines the site structure
}

read_config();

function MARC_transform()
{
	global 	$MARC_config,
			$MARCsyn_config,
			$MARC_searchable,
			$MARC_editable,
			$MARC_display_in_list,
			$MARC_display_extended;

	$searchable_list = array();
	$displayable_list = array();


	//<----- $MARC_searchable ----->
	$searchable_list = explode(",", $MARCsyn_config['searchable']);
	foreach ($searchable_list as $searchable) {
		if(!array_key_exists($searchable, $MARC_config))
			continue;
		else
			array_push($MARC_searchable, $searchable);
	}


	//<----- $MARC_display_in_list ----->
	$displayable_list = explode(",", $MARCsyn_config['display_in_list']);

	foreach ($displayable_list as $displayable) {
		if(!array_key_exists($displayable, $MARC_config) || !array_key_exists($displayable, $MARCsyn_config))
			continue;
		else
			array_push($MARC_display_in_list, $displayable);
	}


	//<----- $MARC_display_extended ----->
	if($MARCsyn_config['display_extended'] == "all") {
		foreach ($MARCsyn_config as $key => $value) {
			if (array_key_exists($key, $MARC_config))
				array_push($MARC_display_extended, $key);
		}
	}
	else {
		$display_extended_list = explode(",", $MARCsyn_config['display_extended']);

		foreach ($display_extended_list as $display_extended) {
			if(!array_key_exists($display_all, $MARC_config) || !array_key_exists($display_all, $MARCsyn_config))
				continue;
			else
				array_push($MARC_display_extended, $display_all);
		}
	}


	//<----- $MARC_editable ----->
	if($MARCsyn_config['editable'] == "all") {
		foreach ($MARC_config as $key => $value) {
			array_push($MARC_editable, $key);
		}
	}
	else {
		$editable_list = explode(",", $MARCsyn_config['editable']);
		array_push($MARC_editable, "001", "003", "005");

		foreach ($editable_list as $editable) {
			if(!array_key_exists($editable, $MARC_config))
				continue;
			else
				array_push($MARC_editable, $display_all);
		}
	}
}

MARC_transform();

function config_to_array($config_file, $separator = ',')
{
	$config_array = parse_ini_file($config_file, TRUE) or die("Config file $config_file not found!");

	foreach ($config_array as $key1 => $value1)
	{
		if (is_array($value1)) {  //watch out for sections in config w/o variables

			foreach ($value1 as $key2 => $value2)
			{
				if (strstr($value2, $separator)) {
					//remove all separators
					$config_array[$key1][$key2] = explode($separator, trim($value2));

					foreach ($config_array[$key1][$key2] as $key3 => $value3) {
						$config_array[$key1][$key2][$key3] = trim($value3);
					}
				}
			}

		}
	}

	return $config_array;
}

function get_page_config($args = array(), $page_id = '')
{
	global	$PageID,		//should this function be moved somewhere else because of this variable??
			$page_config;

	if ($page_id == '')
		$page_id = $PageID;

	$return_args = array(
					'href' => '',
					'permissions' => '',
					'title' => '',
					'stylesheet' => '',
					'scripts' => '',
					'onload' => '',
					'menu_text' => '',
					'menu_target' => ''
					);

	foreach ($return_args as $variable => $value)
	{
		if (array_key_exists($variable, $page_config[$page_id])) {  //if the page has a config value, use it
			$return_args[$variable] = $page_config[$page_id][$variable];
		}
		else {  //else use the site default
			$return_args[$variable] = $page_config['default'][$variable];
		}

		if (is_array($args) && array_key_exists($variable, $args)) {  //the argument always overwrites config settings
			$return_args[$variable] = $args[$variable];
		}
	}

	foreach ($return_args as $variable => $value)
	{
		if ($variable == 'menu_text' && $value == $page_config['default']['menu_text'])
		{
			$return_args['menu_text'] = $page_id;
		}
	}

	return $return_args;
}

function MARC_defs($config = 'MARC_defs')
{
	$final = array();

	$handle = fopen ($config, "r");
	$contents = fread ($handle, filesize ($config));
	fclose ($handle);
	
	$data = explode("\n", $contents);
	
	foreach($data as $row)
	{
		if($row != "") {
			$value_array = array();
			
			$pair = split("\t", $row);
			$key = $pair[0];
			$value = $pair[1];
			
			if($key == 'ind1' || $key == 'ind2') {
				if($value == 'blank') {
					array_push($value_array, 'b');
				} else {
					if(stristr($value, '-')) {
						$limits = explode('-', $value);
						$i=$limits[0];
						while($i <= $limits[1]) {
							array_push($value_array, $i);
							$i++;
						}
					} else {
						$value_array = preg_split('//', $value, -1, PREG_SPLIT_NO_EMPTY);
					}
				}
			} else {
				$parsed_value = $key;
			}

			if(strlen($key) == 3 && is_numeric($key)) {
				$field = $key;
				$final[$key] = array();
				$final[$key]['ind1'] = array();
				$final[$key]['ind2'] = array();
				$final[$key]['fields'] = array();
			} else {
				if ($key == 'ind1') {
					$final[$field]['ind1'] = array_merge($final[$field]['ind1'], $value_array);
				} elseif ($key == 'ind2') {
					$final[$field]['ind2'] = array_merge($final[$field]['ind2'], $value_array);
				} else {
					array_push($final[$field]['fields'], $parsed_value);
				}
			}
		}
	}
	
	/*print "<pre>";
	print_r($final);
	print "</pre>";*/
	
	return $final;
}

?>
